# Contributing to Gort

Thank you for your interest in contributing to Gort. We are grateful for contributions of all kinds; reporting issues, updating documentation, fixing bugs, implementing new features, and any other type of contribution is hugely beneficial to Gort and our community. We're excited to see what you come up with!

Before submitting your contribution, please review the following guidelines. These are intended to make the contribution process as simple and predictable as possible for both contributors and project maintainers.

Please note we have a code of conduct, please follow it in all your interactions with the project.

## Pull Request Workflow

1. Fork the project repository and create a topic branch in your fork for your work. This fork should almost always be made against the `main` branch of the project you're working on, unless you have previously discussed basing your changes on a different branch with the team.
2. Make your changes, including any necessary tests to cover new features or fixes that you make.
3. Ensure that all tests pass.
4. Submit a Pull Request against the `develop` branch of the project you're working on.
5. The project committers review pull requests regularly and will work with contributors to provide feedback and guidance around any changes that are required before the pull request can be accepted.
6. You may merge the Pull Request once your change is accepted. If you do not have permission to do that, you may request the reviewer to merge it for you.

## Code of Conduct

All project contributors are required to behave in accordance with our [Code of Conduct](https://github.com/getgort/gort/blob/master/CODE_OF_CONDUCT.md), which is adapted from the [Contributor Covenant](http://contributor-covenant.org/). Please report any behavior that violates the code of conduct to [matthew.titmus@gmail.com](mailto:matthew.titmus@gmail.com) or to Matt Titmus or Tom Elliott on the [Gort Slack Community](https://join.slack.com/t/getgort/shared_invite/zt-z1elsl5i-XvkiBPHqUOTDUUH1j9dSbg) so that we can investigate and take appropriate action.
